## ck 0.7.2

=== regressions/Makefile ===
DIR=array	\
    backoff	\
    barrier	\
    bitmap	\
    brlock	\
    bytelock	\
    cc		\
    cohort	\
    ec		\
    epoch	\
    fifo	\
    hp		\
    hs		\
    rhs		\
    ht		\
    pflock	\
    pr		\
    queue	\
    ring	\
    rwlock	\
    sequence	\
    spinlock	\
    stack	\
    swlock	\
    tflock

.PHONY: all clean check

all:
	$(MAKE) -C ./ck_array/validate all
	$(MAKE) -C ./ck_cc/validate all
	$(MAKE) -C ./ck_cohort/validate all
	$(MAKE) -C ./ck_cohort/benchmark all
	$(MAKE) -C ./ck_bitmap/validate all
	$(MAKE) -C ./ck_backoff/validate all
	$(MAKE) -C ./ck_queue/validate all
	$(MAKE) -C ./ck_brlock/validate all
	$(MAKE) -C ./ck_ht/validate all
	$(MAKE) -C ./ck_ht/benchmark all
	$(MAKE) -C ./ck_brlock/benchmark all
	$(MAKE) -C ./ck_spinlock/validate all
	$(MAKE) -C ./ck_spinlock/benchmark all
	$(MAKE) -C ./ck_fifo/validate all
	$(MAKE) -C ./ck_fifo/benchmark all
	$(MAKE) -C ./ck_pr/validate all
	$(MAKE) -C ./ck_pr/benchmark all
	$(MAKE) -C ./ck_hs/benchmark all
	$(MAKE) -C ./ck_hs/validate all
	$(MAKE) -C ./ck_rhs/benchmark all
	$(MAKE) -C ./ck_rhs/validate all
	$(MAKE) -C ./ck_barrier/validate all
	$(MAKE) -C ./ck_barrier/benchmark all
	$(MAKE) -C ./ck_bytelock/validate all
	$(MAKE) -C ./ck_bytelock/benchmark all
	$(MAKE) -C ./ck_epoch/validate all
	$(MAKE) -C ./ck_rwcohort/validate all
	$(MAKE) -C ./ck_rwcohort/benchmark all
	$(MAKE) -C ./ck_sequence/validate all
	$(MAKE) -C ./ck_sequence/benchmark all
	$(MAKE) -C ./ck_stack/validate all
	$(MAKE) -C ./ck_stack/benchmark all
	$(MAKE) -C ./ck_ring/validate all
	$(MAKE) -C ./ck_ring/benchmark all
	$(MAKE) -C ./ck_rwlock/validate all
	$(MAKE) -C ./ck_rwlock/benchmark all
	$(MAKE) -C ./ck_tflock/validate all
	$(MAKE) -C ./ck_tflock/benchmark all
	$(MAKE) -C ./ck_swlock/validate all
	$(MAKE) -C ./ck_swlock/benchmark all
	$(MAKE) -C ./ck_pflock/validate all
	$(MAKE) -C ./ck_pflock/benchmark all
	$(MAKE) -C ./ck_hp/validate all
	$(MAKE) -C ./ck_hp/benchmark all
	$(MAKE) -C ./ck_ec/validate all
	$(MAKE) -C ./ck_ec/benchmark all

clean:
	$(MAKE) -C ./ck_array/validate clean
	$(MAKE) -C ./ck_cc/validate clean
	$(MAKE) -C ./ck_pflock/validate clean
	$(MAKE) -C ./ck_pflock/benchmark clean
	$(MAKE) -C ./ck_tflock/validate clean
	$(MAKE) -C ./ck_tflock/benchmark clean
	$(MAKE) -C ./ck_rwcohort/validate clean
	$(MAKE) -C ./ck_rwcohort/benchmark clean
	$(MAKE) -C ./ck_backoff/validate clean
	$(MAKE) -C ./ck_bitmap/validate clean
	$(MAKE) -C ./ck_queue/validate clean
	$(MAKE) -C ./ck_cohort/validate clean
	$(MAKE) -C ./ck_cohort/benchmark clean
	$(MAKE) -C ./ck_brlock/validate clean
	$(MAKE) -C ./ck_ht/validate clean
	$(MAKE) -C ./ck_ht/benchmark clean
	$(MAKE) -C ./ck_hs/validate clean
	$(MAKE) -C ./ck_hs/benchmark clean
	$(MAKE) -C ./ck_rhs/validate clean
	$(MAKE) -C ./ck_rhs/benchmark clean
	$(MAKE) -C ./ck_brlock/benchmark clean
	$(MAKE) -C ./ck_spinlock/validate clean
	$(MAKE) -C ./ck_spinlock/benchmark clean
	$(MAKE) -C ./ck_fifo/validate clean
	$(MAKE) -C ./ck_fifo/benchmark clean
	$(MAKE) -C ./ck_pr/validate clean
	$(MAKE) -C ./ck_pr/benchmark clean
	$(MAKE) -C ./ck_barrier/validate clean
	$(MAKE) -C ./ck_barrier/benchmark clean
	$(MAKE) -C ./ck_bytelock/validate clean
	$(MAKE) -C ./ck_bytelock/benchmark clean
	$(MAKE) -C ./ck_epoch/validate clean
	$(MAKE) -C ./ck_sequence/validate clean
	$(MAKE) -C ./ck_sequence/benchmark clean
	$(MAKE) -C ./ck_stack/validate clean
	$(MAKE) -C ./ck_stack/benchmark clean
	$(MAKE) -C ./ck_ring/validate clean
	$(MAKE) -C ./ck_ring/benchmark clean
	$(MAKE) -C ./ck_rwlock/validate clean
	$(MAKE) -C ./ck_rwlock/benchmark clean
	$(MAKE) -C ./ck_swlock/validate clean
	$(MAKE) -C ./ck_swlock/benchmark clean
	$(MAKE) -C ./ck_pflock/validate clean
	$(MAKE) -C ./ck_pflock/benchmark clean
	$(MAKE) -C ./ck_hp/validate clean
	$(MAKE) -C ./ck_hp/benchmark clean
	$(MAKE) -C ./ck_ec/validate clean
	$(MAKE) -C ./ck_ec/benchmark clean

check: all
	rc=0; 							\
	for d in $(DIR) ; do					\
		echo "----[ Testing $$d....";			\
		$(MAKE) -C ./ck_$$d/validate check || rc=1; 	\
		echo;						\
	done; 							\
	exit $$rc

=== regressions/ck_array/validate/Makefile ===
.PHONY: check clean distribution

OBJECTS=serial

all: $(OBJECTS)

serial: serial.c ../../../include/ck_array.h ../../../src/ck_array.c
	$(CC) $(CFLAGS) -o serial serial.c ../../../src/ck_array.c

check: all
	./serial

clean:
	rm -rf *~ *.o $(OBJECTS) *.dSYM *.exe

include ../../../build/regressions.build
CFLAGS+=-D_GNU_SOURCE -ggdb

=== regressions/ck_backoff/validate/Makefile ===
.PHONY: check clean

all: validate

validate: validate.c ../../../include/ck_backoff.h
	$(CC) $(CFLAGS) -o validate validate.c

check: all
	./validate

clean:
	rm -rf validate *.dSYM *.exe

include ../../../build/regressions.build
CFLAGS+=-D_GNU_SOURCE

=== regressions/ck_cc/validate/Makefile ===
.PHONY: check clean distribution

OBJECTS=ck_cc

all: $(OBJECTS)

ck_cc: ck_cc.c ../../../include/ck_cc.h
	$(CC) $(CFLAGS) -g2 -o ck_cc ck_cc.c

check: all
	./ck_cc

clean:
	rm -rf *~ *.o $(OBJECTS) *.dSYM *.exe

include ../../../build/regressions.build
CFLAGS+=-D_GNU_SOURCE

=== regressions/ck_ec/benchmark/Makefile ===
.PHONY: check clean distribution

OBJECTS=ck_ec

all: $(OBJECTS)

ck_ec: ck_ec.c ../../../include/ck_ec.h
	$(CC) $(CFLAGS) ../../../src/ck_ec.c -o ck_ec ck_ec.c

check: all
	./ck_ec $(CORES) 1

clean:
	rm -rf *~ *.o $(OBJECTS) *.dSYM *.exe

include ../../../build/regressions.build
CFLAGS+=-D_GNU_SOURCE

=== regressions/ck_epoch/validate/Makefile ===
.PHONY: check clean distribution

OBJECTS=ck_stack ck_epoch_synchronize ck_epoch_poll ck_epoch_call \
	ck_epoch_section ck_epoch_section_2 torture
HALF=`expr $(CORES) / 2`

all: $(OBJECTS)

check: all
	./ck_stack $(CORES) 1
	./ck_epoch_synchronize $(HALF) $(HALF) 1
	./ck_epoch_poll $(CORES) 1 1
	./ck_epoch_section
	./ck_epoch_section_2 $(HALF) $(HALF) 1
	./torture $(HALF) $(HALF) 1

ck_epoch_synchronize: ck_epoch_synchronize.c ../../../include/ck_stack.h ../../../include/ck_epoch.h ../../../src/ck_epoch.c
	$(CC) $(CFLAGS) -o ck_epoch_synchronize ck_epoch_synchronize.c ../../../src/ck_epoch.c

ck_epoch_poll: ck_epoch_poll.c ../../../include/ck_stack.h ../../../include/ck_epoch.h ../../../src/ck_epoch.c
	$(CC) $(CFLAGS) -o ck_epoch_poll ck_epoch_poll.c ../../../src/ck_epoch.c

torture: torture.c ../../../include/ck_epoch.h ../../../src/ck_epoch.c
	$(CC) $(CFLAGS) -o torture torture.c ../../../src/ck_epoch.c

ck_epoch_section: ck_epoch_section.c ../../../include/ck_epoch.h ../../../src/ck_epoch.c
	$(CC) $(CFLAGS) -o ck_epoch_section ck_epoch_section.c ../../../src/ck_epoch.c

ck_epoch_section_2: ck_epoch_section_2.c ../../../include/ck_epoch.h ../../../src/ck_epoch.c
	$(CC) $(CFLAGS) -o ck_epoch_section_2 ck_epoch_section_2.c ../../../src/ck_epoch.c

ck_epoch_call: ck_epoch_call.c ../../../include/ck_stack.h ../../../include/ck_epoch.h ../../../src/ck_epoch.c
	$(CC) $(CFLAGS) -o ck_epoch_call ck_epoch_call.c ../../../src/ck_epoch.c

ck_stack: ck_stack.c ../../../include/ck_stack.h ../../../include/ck_epoch.h ../../../src/ck_epoch.c
	$(CC) $(CFLAGS) -o ck_stack ck_stack.c ../../../src/ck_epoch.c

clean:
	rm -rf *~ *.o $(OBJECTS) *.dSYM *.exe

include ../../../build/regressions.build
CFLAGS+=$(PTHREAD_CFLAGS) -D_GNU_SOURCE

=== regressions/ck_pr/validate/Makefile ===
.PHONY: check clean distribution

OBJECTS=ck_pr_cas ck_pr_faa ck_pr_inc ck_pr_dec ck_pr_bts \
	ck_pr_btr ck_pr_btc ck_pr_load ck_pr_store 	  \
	ck_pr_and ck_pr_or ck_pr_xor ck_pr_add ck_pr_sub  \
	ck_pr_fas ck_pr_bin ck_pr_btx ck_pr_fax ck_pr_n	  \
	ck_pr_unary ck_pr_fence ck_pr_dec_zero ck_pr_inc_zero

all: $(OBJECTS)

check: all
	for d in $(OBJECTS) ; do        \
		echo $$d;		\
		./$$d || exit 1;     	\
	done;

ck_pr_cas: ck_pr_cas.c
	$(CC) $(CFLAGS) -o ck_pr_cas ck_pr_cas.c

ck_pr_inc: ck_pr_inc.c
	$(CC) $(CFLAGS) -o ck_pr_inc ck_pr_inc.c

ck_pr_inc_zero: ck_pr_inc_zero.c
	$(CC) $(CFLAGS) -o ck_pr_inc_zero ck_pr_inc_zero.c

ck_pr_dec: ck_pr_dec.c
	$(CC) $(CFLAGS) -o ck_pr_dec ck_pr_dec.c

ck_pr_dec_zero: ck_pr_dec_zero.c
	$(CC) $(CFLAGS) -o ck_pr_dec_zero ck_pr_dec_zero.c

ck_pr_faa: ck_pr_faa.c
	$(CC) $(CFLAGS) -o ck_pr_faa ck_pr_faa.c

ck_pr_fence: ck_pr_fence.c
	$(CC) $(CFLAGS) -o ck_pr_fence ck_pr_fence.c

ck_pr_btc: ck_pr_btc.c
	$(CC) $(CFLAGS) -o ck_pr_btc ck_pr_btc.c

ck_pr_btr: ck_pr_btr.c
	$(CC) $(CFLAGS) -o ck_pr_btr ck_pr_btr.c

ck_pr_bts: ck_pr_bts.c
	$(CC) $(CFLAGS) -o ck_pr_bts ck_pr_bts.c

ck_pr_load: ck_pr_load.c
	$(CC) $(CFLAGS) -o ck_pr_load ck_pr_load.c

ck_pr_store: ck_pr_store.c
	$(CC) $(CFLAGS) -o ck_pr_store ck_pr_store.c

ck_pr_and: ck_pr_and.c
	$(CC) $(CFLAGS) -o ck_pr_and ck_pr_and.c

ck_pr_or: ck_pr_or.c
	$(CC) $(CFLAGS) -o ck_pr_or ck_pr_or.c

ck_pr_xor: ck_pr_xor.c
	$(CC) $(CFLAGS) -o ck_pr_xor ck_pr_xor.c

ck_pr_add: ck_pr_add.c
	$(CC) $(CFLAGS) -o ck_pr_add ck_pr_add.c

ck_pr_sub: ck_pr_sub.c
	$(CC) $(CFLAGS) -o ck_pr_sub ck_pr_sub.c

ck_pr_fas: ck_pr_fas.c
	$(CC) $(CFLAGS) -o ck_pr_fas ck_pr_fas.c

ck_tp: ck_tp.c
	$(CC) $(CFLAGS) -o ck_tp ck_tp.c

ck_pr_bin: ck_pr_bin.c
	$(CC) $(CFLAGS) -o ck_pr_bin ck_pr_bin.c

ck_pr_btx: ck_pr_btx.c
	$(CC) $(CFLAGS) -o ck_pr_btx ck_pr_btx.c

ck_pr_fax: ck_pr_fax.c
	$(CC) $(CFLAGS) -o ck_pr_fax ck_pr_fax.c

ck_pr_n: ck_pr_n.c
	$(CC) $(CFLAGS) -o ck_pr_n ck_pr_n.c

ck_pr_unary: ck_pr_unary.c
	$(CC) $(CFLAGS) -o ck_pr_unary ck_pr_unary.c

clean:
	rm -rf *~ *.o $(OBJECTS) *.dSYM *.exe

include ../../../build/regressions.build
CFLAGS+=-D_GNU_SOURCE

=== regressions/ck_queue/validate/Makefile ===
.PHONY: check clean distribution

HEADER=../../../include/ck_queue.h
OBJECTS=ck_list ck_slist ck_stailq

all: $(OBJECTS)

check: all
	./ck_list $(CORES) 5
	./ck_slist $(CORES) 5
	./ck_stailq $(CORES) 1000000

ck_list: $(HEADER) ck_list.c
	$(CC) $(CFLAGS) -o ck_list ck_list.c

ck_slist: $(HEADER) ck_slist.c
	$(CC) $(CFLAGS) -o ck_slist ck_slist.c

ck_stailq: $(HEADER) ck_stailq.c
	$(CC) $(CFLAGS) -o ck_stailq ck_stailq.c

clean:
	rm -rf *~ *.o $(OBJECTS) *.dSYM *.exe

include ../../../build/regressions.build
CFLAGS+=$(PTHREAD_CFLAGS) -D_GNU_SOURCE

=== regressions/ck_spinlock/validate/Makefile ===
.PHONY: check clean

all: ck_ticket ck_mcs ck_dec ck_cas ck_fas ck_clh linux_spinlock \
     ck_ticket_pb ck_anderson ck_spinlock ck_hclh

check: all
	./ck_ticket $(CORES) 1
	./ck_mcs $(CORES) 1
	./ck_dec $(CORES) 1
	./ck_cas $(CORES) 1
	./ck_fas $(CORES) 1
	./ck_clh $(CORES) 1
	./ck_hclh $(CORES) 1
	./linux_spinlock $(CORES) 1
	./ck_ticket_pb $(CORES) 1
	./ck_anderson $(CORES) 1
	./ck_spinlock $(CORES) 1

linux_spinlock: linux_spinlock.c
	$(CC) $(CFLAGS) -o linux_spinlock linux_spinlock.c

ck_spinlock: ck_spinlock.c
	$(CC) $(CFLAGS) -o ck_spinlock ck_spinlock.c

ck_ticket_pb: ck_ticket_pb.c
	$(CC) $(CFLAGS) -o ck_ticket_pb ck_ticket_pb.c

ck_clh: ck_clh.c
	$(CC) $(CFLAGS) -o ck_clh ck_clh.c

ck_hclh: ck_hclh.c
	$(CC) $(CFLAGS) -o ck_hclh ck_hclh.c

ck_anderson: ck_anderson.c
	$(CC) $(CFLAGS) -o ck_anderson ck_anderson.c

ck_fas: ck_fas.c
	$(CC) $(CFLAGS) -o ck_fas ck_fas.c

ck_ticket: ck_ticket.c
	$(CC) $(CFLAGS) -o ck_ticket ck_ticket.c

ck_cas: ck_cas.c
	$(CC) $(CFLAGS) -o ck_cas ck_cas.c

ck_mcs: ck_mcs.c
	$(CC) $(CFLAGS) -o ck_mcs ck_mcs.c

ck_dec: ck_dec.c
	$(CC) $(CFLAGS) -o ck_dec ck_dec.c

clean:
	rm -rf ck_ticket ck_mcs ck_dec ck_cas ck_fas ck_clh linux_spinlock ck_ticket_pb \
		ck_anderson ck_spinlock ck_hclh *.dSYM *.exe

include ../../../build/regressions.build
CFLAGS+=$(PTHREAD_CFLAGS) -D_GNU_SOURCE -lm

=== regressions/ck_tflock/benchmark/Makefile ===
.PHONY: clean distribution

OBJECTS=latency throughput

all: $(OBJECTS)

latency: latency.c ../../../include/ck_rwlock.h ../../../include/ck_elide.h
	$(CC) $(CFLAGS) -o latency latency.c

throughput: throughput.c ../../../include/ck_rwlock.h ../../../include/ck_elide.h
	$(CC) $(CFLAGS) -o throughput throughput.c

clean:
	rm -rf *.dSYM *.exe *~ *.o $(OBJECTS)

include ../../../build/regressions.build
CFLAGS+=$(PTHREAD_CFLAGS) -D_GNU_SOURCE

=== debian/changelog ===
ck (0.7.2-6) sid; urgency=medium

  * Simplifying watch file.

 -- Daniel Baumann <daniel@debian.org>  Fri, 25 Apr 2025 21:02:45 +0200

ck (0.7.2-5) sid; urgency=medium

  * Removing multi-arch field for libck-dev (Closes: #1100922).

 -- Daniel Baumann <daniel@debian.org>  Thu, 20 Mar 2025 15:15:29 +0100

ck (0.7.2-4) sid; urgency=medium

  * Using codename instead of suitename in changelog.

 -- Daniel Baumann <daniel@debian.org>  Thu, 20 Mar 2025 07:53:41 +0100

ck (0.7.2-3) sid; urgency=medium

  * Updating to standards version 4.7.1.
  * Updating to standards version 4.7.2.

 -- Daniel Baumann <daniel@debian.org>  Wed, 19 Mar 2025 19:18:55 +0100

ck (0.7.2-2) sid; urgency=medium

  * Updating source url in copyright.
  * Re-adding missing changelog for 0.7.1-12.1~exp1.
  * Updating vcs fields.
  * Updating my email address.
  * Trimming debian changelog.
  * Updating year in debian copyright for 2025.

 -- Daniel Baumann <daniel@debian.org>  Sun, 09 Feb 2025 07:58:38 +0100

ck (0.7.2-1) sid; urgency=medium

  * Merging upstream version 0.7.2.
  * Updating to standards-version 4.7.0.
  * Removing cc-builtins.patch, included upstream.
  * Removing disable-sse.patch, included upstream.
  * Refreshing ftbfs-armhf.patch.
  * Renumbering remaining patch.

 -- Daniel Baumann <daniel@debian.org>  Mon, 08 Apr 2024 09:50:31 +0200

ck (0.7.1-13) sid; urgency=medium

  * Bumping build-depends on debhelper for t64 transition.
  * Wrap and sorting debian files.
  * Updating copyright for 2024.

 -- Daniel Baumann <daniel@debian.org>  Mon, 04 Mar 2024 07:05:29 +0100

ck (0.7.1-12.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062061

 -- Steve Langasek <vorlon@debian.org>  Wed, 28 Feb 2024 15:42:20 +0000

ck (0.7.1-12.1~exp1) experimental; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.

 -- Steve Langasek <vorlon@debian.org>  Wed, 31 Jan 2024 08:55:15 +0000

ck (0.7.1-12) sid; urgency=medium

  * Skipping tests when building non-parallel to fix hanging test suite,
    thanks to Santiago Vila <sanvila@debian.org> (Closes: #1055218).

 -- Daniel Baumann <daniel@debian.org>  Sun, 10 Dec 2023 10:44:25 +0100

ck (0.7.1-11) sid; urgency=medium

  * Removing generated files to fix FTBFS when build twice in a row
    (Closes: #1043762).

 -- Daniel Baumann <daniel@debian.org>  Mon, 14 Aug 2023 10:04:37 +0200

ck (0.7.1-10) sid; urgency=medium

  * Updating packaging copyright as it has completely replaced/redone.

 -- Daniel Baumann <daniel@debian.org>  Mon, 30 Jan 2023 17:17:29 +0100

ck (0.7.1-9) sid; urgency=medium

  * Updating http links to https in copyright.
  * Updating to standards version 4.6.2.

 -- Daniel Baumann <daniel@debian.org>  Wed, 25 Jan 2023 09:15:20 +0100

ck (0.7.1-8) sid; urgency=medium

  * Updating to standards version 4.6.1.
  * Adding patch from Steve Langasek <steve.langasek@canonical.com> to fix
    FTBFS on armhf (Closes: #1009622).

 -- Daniel Baumann <daniel@debian.org>  Thu, 07 Jul 2022 10:14:36 +0200

ck (0.7.1-7) sid; urgency=medium

  * Overwriting armhf platform target to fix FTBFS with newer GCC (Closes:
    #1009622).

 -- Daniel Baumann <daniel@debian.org>  Wed, 13 Apr 2022 08:50:08 +0200

ck (0.6.0-2) sid; urgency=medium

  * New maintainer (Closes: #991427), thanks to Robert for his past work.
  * Updating vcs fields.

 -- Daniel Baumann <daniel@debian.org>  Fri, 23 Jul 2021 13:25:19 +0200

=== debian/control ===
Source: ck
Section: libs
Priority: optional
Maintainer: Daniel Baumann <daniel@debian.org>
Build-Depends:
 debhelper (>= 13.14~),
 debhelper-compat (= 13),
 dpkg-dev (>= 1.22.5),
Rules-Requires-Root: no
Standards-Version: 4.7.2
Homepage: http://concurrencykit.org
Vcs-Browser: https://forgejo.debian.net/dns-oarc/ck
Vcs-Git: https://forgejo.debian.net/dns-oarc/ck

Package: libck-dev
Section: libdevel
Architecture: linux-any
Depends:
 libck0t64 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Concurrency Kit (development)
 The Concurrency Kit library implements concurrency primitives, safe memory
 reclamation mechanisms and non-blocking data structures for the research,
 design and implementation of high performance concurrent systems.
 .
 This package contains the development files.

Package: libck0t64
Provides:
 ${t64:Provides},
Replaces:
 libck0,
Breaks:
 libck0 (<< ${source:Version}),
Section: libs
Architecture: linux-any
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Concurrency Kit (library)
 The Concurrency Kit library implements concurrency primitives, safe memory
 reclamation mechanisms and non-blocking data structures for the research,
 design and implementation of high performance concurrent systems.
 .
 It features atomic operations, hardware transactional memory, memory barriers,
 hash tables, list, ring, stack, fifo, bitmap, safe memory reclamation,
 scalable locks, execution barriers, asymmetric synchronization and more.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

ifneq (,$(filter $(DEB_HOST_ARCH), armel x32))
	PLATFORM = --platform=unknown
endif

ifeq ($(DEB_HOST_ARCH),armhf)
	DEB_CFLAGS_MAINT_APPEND = -march=armv7-a+fp
	export DEB_CFLAGS_MAINT_APPEND
endif

ifeq ($(DEB_HOST_ARCH), i386)
	PLATFORM = --disable-sse
endif

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
else
	NUMJOBS = 1
endif

%:
	dh ${@}

execute_after_dh_auto_clean:
	# remove generated files
	rm -f doc/*.gz src/*.a src/*.so
	for FILE in $$(find . -type f -name "*.in"); \
	do \
		rm -f "$$(dirname "$${FILE}")"/"$$(basename "$${FILE}" .in)"; \
	done

override_dh_auto_configure:
	dh_auto_configure -- \
		--prefix=/usr \
		--libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
		--includedir=/usr/include \
		--mandir=/usr/share/man \
		--cores=2 \
		$(PLATFORM)

override_dh_auto_test:
ifneq (,$(filter $(DEB_HOST_ARCH), amd64 arm64 i386))
ifneq ($(NUMJOBS), 1)
	$(MAKE) -j1 check
endif
endif

=== debian/watch ===
version=4
https://github.com/concurrencykit/ck/tags .*/v?(\d.*)@ARCHIVE_EXT@
